unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Inifiles,
  SynEdit, SynFacilHighlighter;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    ColorDialog1: TColorDialog;
    SynEdit1: TSynEdit;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private

  public
    IniFile: TIniFile;
    KeywordColor: TColor;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

var
  Hlt: TSynFacilSyn;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  IniFile := TIniFile.Create('test.ini');
  // This does not work, the default color is not used, and the color saved to the Inifile is not read either
  KeywordColor := IniFile.ReadInteger('Colors', 'Keywords', clBlue);
  Hlt := TSynFacilSyn.Create(self);
  SynEdit1.Highlighter := Hlt;
  Hlt.LoadFromFile('ObjectPascal.xml');
  SynEdit1.Lines.LoadFromFile('ObjectPascal_sample.txt');
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if ColorDialog1.Execute then
  begin
    KeywordColor := ColorDialog1.Color;
    // This works, SynEdit keyword colors are changed to the selected color
    Hlt.tkKeyword.Foreground := KeywordColor;
    SynEdit1.Invalidate;
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  // This works, color is succssfully save dto Inifile.
  IniFile.WriteInteger('Colors', 'Keywords', KeywordColor);
  IniFile.Free;
  Hlt.Free;
end;

end.
